"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _helpers = require("../helpers/helpers");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formField = _interopRequireDefault(require("../form-field/form-field"));

var _excluded = ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "validateOnMount", "meta", "FormFieldGridProps", "HelperTextProps"];

var DatePicker = function DatePicker(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      HelperTextProps = _useFieldApi.HelperTextProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_formField["default"], (0, _extends2["default"])({
    label: label
  }, input, {
    type: "date",
    required: isRequired,
    error: invalid && {
      content: meta.error || meta.submitError
    }
  }, rest, {
    control: function control(props) {
      return /*#__PURE__*/_react["default"].createElement("input", (0, _extends2["default"])({}, props, {
        readOnly: isReadOnly,
        disabled: isDisabled,
        placeholder: placeholder
      }));
    }
  })));
};

DatePicker.propTypes = {
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  description: _propTypes["default"].node,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object
};
DatePicker.defaultProps = {
  FormFieldGridProps: {},
  HelperTextProps: {}
};
var _default = DatePicker;
exports["default"] = _default;